const { DataTypes } = require("sequelize");

module.exports = (sequelize) => {
	const BloodGroup = sequelize.define(
		"bloodgroup",
		{
			id: {
				type: DataTypes.INTEGER,
				autoIncrement: true,
				primaryKey: true,
			},
			creation: { type: DataTypes.DATE, allowNull: false },
			modified: { type: DataTypes.DATE, allowNull: false },
			modified_by: { type: DataTypes.INTEGER, allowNull: false },
			owner: { type: DataTypes.INTEGER, allowNull: false },
			enabled: { type: DataTypes.BOOLEAN, allowNull: false },

			// main
			name: { type: DataTypes.STRING(50), allowNull: false },
			display_name: { type: DataTypes.STRING(50), allowNull: false },

			// fk
			company_id: {
				type: DataTypes.INTEGER,
				allowNull: true,
			},
		},
		{
			tableName: "bloodgroups",
			freezeTableName: true,
		}
	);

	/**
	 * Associates the BloodGroup model with other models.
	 * @param {object} models - The models to associate with.
	 * @description
	 */
	BloodGroup.associate = (models) => {
		BloodGroup.belongsTo(models.Company, {
			foreignKey: "company_id",
			as: "company",
		});

		BloodGroup.hasMany(models.Employee, {
			foreignKey: "bloodgroup_id",
			as: "employees",
		});
		
		BloodGroup.hasMany(models.Patient, {
			foreignKey: "bloodgroup_id",
			as: "patients",
		});
	};

	return BloodGroup;
};
